/*
 * Author: Jake G
 * Date: 2024-09-01
 * filename: Relays.c
 * description: module_purpose
 */

#include "Relays.h"

/*
static void WaitForRelayConnect(void) {
  while (!(PORTA.IN & RELAYREADINGPIN)) {
    ;
  }
}

static void WaitForRelayDisconnect(void) {
  while (PORTA.IN & RELAYREADINGPIN) {
    ;
  }
}
*/

void Relay_MeasureMakeTime(Relay *relay) {}

void Relay_MeasureBreakTime(Relay *relay) {}

void Relay_Enable(Relay *relay) {
  if (relay->disabled_fpc) {
    return;
  }

  (*(uint8_t *)relay->output_port) |= (1 << (relay->output_pin));
}

void Relay_Disable(Relay *relay) {
  if (relay->disabled_fpc) {
    return;
  }

  (*(uint8_t *)relay->output_port) &= ~(1 << (relay->output_pin));
}

void Relay_DisableForPowerCycle(Relay *relay) { relay->disabled_fpc = true; }

bool Relay_ReadState(Relay *relay) {
  if (*(uint8_t *)relay->input_port & (1 << relay->input_pin)) {
    return true;
  }
  return false;
}
